﻿Option Strict On

Public Interface IPlugin
    Inherits System.IDisposable

    ReadOnly Property Name() As String
    Function Run(ByVal param As Object) As Object

End Interface




Friend NotInheritable Class ExternalType
    Private ReadOnly m_Name As String
    Private ReadOnly m_Type As Type

    Public Sub New(ByVal Name As String, ByVal Type As Type)
        Me.m_Name = Name
        Me.m_Type = Type
    End Sub

    Public ReadOnly Property Name() As String
        Get
            Return Me.m_Name
        End Get
    End Property

    Public ReadOnly Property Type() As Type
        Get
            Return Me.m_Type
        End Get
    End Property

    Public Function CreateNew(Of T)() As T
        Return CType(System.Activator.CreateInstance(Me.Type), T)
    End Function

End Class
